"use strict";
/**
 *   author: Carson Cao
 *   date:   2017/5/17  
 **/

var db;

function LocalStorage() {}
db = LocalStorage;

db.prototype.getItem = function(key) {
    if (this.hasOwnProperty(key)) {
        return this[key];
    }
    return null;
};

db.prototype.setItem = function(key, val) {
    this[key] = val;
};

db.prototype.removeItem = function(key) {
    delete this[key];
};

db.prototype.clear = function() {
    var self = this;
    Object.keys(self).forEach(function(key) {
        self[key] = undefined;
        delete self[key];
    });
};

db.prototype.key = function(i) {
    i = i || 0;
    return Object.keys(this)[i];
};

db.prototype.__defineGetter__('length', function() {
    return Object.keys(this).length;
});

if (global.localStorage) {
    module.exports = localStorage;
} else {
    module.exports = new LocalStorage();
}
